#include "TestProgramV2_1_1.h"
#define uart_interrupt_enable()  {ES0=1;}
#define uart_interrupt_disable() {ES0=0;}
void uart_init( void )
{  
    // initialize serial port registers
    S0CON = 0x72;  //Mode1, 8bit uart
    PCON = 0x80;   //SMOD0=0;

    // Use Timer 1
    TMOD    = 0x20;     // Timer 1 in mode 2, 8-bit auto-reload 
    TR1     = 1;        // Turn on Timer 1 
    TL1 = TH1 = 0xff;   // Set reload value 
    //uart_interrupt_disable();
    ES0=0;
}


void uart_putchar( unsigned char ch )
{  
 // int i;
    if(TI) TI=0; 
    S0BUF = ch;
    while(!TI);  
    TI=0;       
}

unsigned char uart_getchar( void )
{
    unsigned char d;
    
    while(!RI); 
    d=S0BUF;  
    RI=0;     
    return d; 
}

/*EIAJ flicker level, ISO flicker EIAJFlickerֵٷֱȱʾ*/

float read_flick(void)       //32-bit
{
    unsigned char i;
    unsigned char *pbuf;
    unsigned char cmd[12]= ":*amt?flick#";
    float flick=0.0;

    uart_init();
    for(i=0;i<12;i++)
        uart_putchar(cmd[i]);
    pbuf=(unsigned char *)&flick;
    if(0x30 != uart_getchar())
    {
        //Display_Message("flick Error");
        Wait_Halt(500);
        Start_Button(1); 
    }
    else
    {
        for(i=0;i<4;i++)   //BriEye dataӸλλ.

        {
         *(pbuf+i)=uart_getchar();
        }
    }
    return flick;
}


/*
 * return:
 *   0 --- error
 *   1 --- OK
 */
unsigned char read_rgb(float rgb[3])
{
    unsigned char i;
    unsigned char *pbuf;
    unsigned char cmd[11]= ":*amt?rgb#7";
 
    uart_init();
    for(i=0;i<11;i++)
        uart_putchar(cmd[i]);
    
    if(0xE0 != uart_getchar())
    {
        //Display_Message("flick Error");
        Wait_Halt(500);
        Start_Button(1); 
        return 0;
    }
    else
    {   
        pbuf=(unsigned char *)rgb;
        for(i=0;i<12;i++)  //BriEye dataӵλλ?

        {
            *(pbuf+i)=uart_getchar();   
        }
        return 1;
    }
}
/*ʵread_rgbĺǶȡXYZֵ*/
unsigned char read_rgb2(float *x,float *y,float *z)
{
    float rgb[3];
    if(0==read_rgb(rgb))
    {
        *x=0;
        *y=0;
        *z=0;
        return 0;
    }
    else
    {
        *x=rgb[0];
        *y=rgb[1];
        *z=rgb[2];
        return 1;
    }
}
/*У*/
 char DarkCalib(void)
 {
   unsigned char data_temp[11]= ":*fix?dark#";
   float x,y,z;
    unsigned char i;
   read_rgb2(&x,&y,&z);
   Wait(100);
     for(i=0;i<11;i++)
  {
     uart_putchar(data_temp[i]);
  }
  Wait(100);
return 0;
 }

/*modulation amplitude Flicker MAX-MIN*/

   
   float read_flicker_trim()
{
    unsigned char i;
    unsigned char *pbuf;
    unsigned char cmd[15]= ":*flick?maxmin#";
    float max,min;
    uart_init();
    for(i=0;i<15;i++)
      uart_putchar(cmd[i]);
    
    if(0xE0 != uart_getchar())
    {
        //Display_Message("flick Error");
        Wait_Halt(500);
        Start_Button(1); 
        return -1;
    }
    else
    {   
        pbuf=(unsigned char *)&max;
        for(i=0;i<4;i++) *(pbuf+i)=uart_getchar();
        pbuf=(unsigned char *)&min;
        for(i=0;i<4;i++) *(pbuf+i)=uart_getchar();
        return (max-min);
    }
}
